/* Shariks
 *
 * Copyright (C) 2010 Dmitriev V.V.     <vdmitrie@cs.karelia.ru>
 * Copyright (C) 2010 Kirpichonock K.N. <kirpiche@cs.karelia.ru>
 * Copyright (C) 2010 Sotnikov A.A.     <sotnikov@cs.karelia.ru>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifndef BALL_H
#define	BALL_H

#include <SDL.h>
#include "Timer.h"

class Ball {
public:
    Ball();
    Ball(float mass, float radius);
    Ball(float x, float y, float mass, float radius);
    Ball(const Ball& orig);

    bool linked;
    bool fixed;

    int link_start;
    int link_end;

    Timer timer;

    float x, y;   // position
    float dx, dy; // velocity
    float radius;
    float mass;
    SDL_Surface* sprite; // sprite for Ball

    void set_position(float x, float y);
    void reset_velocity();

    virtual ~Ball();
private:

};

#endif	/* BALL_H */

